library InjectedDLL;

{ Important note about DLL memory management: ShareMem must be the
  first unit in your library's USES clause AND your project's (select
  Project-View Source) USES clause if your DLL exports any procedures or
  functions that pass strings as parameters or function results. This
  applies to all strings passed to and from your DLL--even those that
  are nested in records and classes. ShareMem is the interface unit to
  the BORLNDMM.DLL shared memory manager, which must be deployed along
  with your DLL. To avoid using BORLNDMM.DLL, pass string information
  using PChar or ShortString parameters. }

uses
  SysUtils,
  Classes,
  Windows,
  Messages;

{$R *.res}

function Echo(aStr: string): string; stdcall;
begin
  Result:= aStr;
end;

exports
  Echo;

function EnumWindowsProc(Wnd: HWND; PID: Cardinal): BOOL; stdcall;
var
  wPID: Cardinal;
  Text: PChar;

begin
  GetWindowThreadProcessId(Wnd, wPID);
  Result:= (wPID <> PID);
  if not Result then
  begin
    Text:= 'Injected!';
    SendMessage(Wnd, WM_SETTEXT, 0, Integer(Text));
  end;

end;

begin
  EnumWindows(@EnumWindowsProc, GetCurrentProcessId);
end.
